/*
 * Copyright 2010-2014 Ning, Inc.
 * Copyright 2014-2020 Groupon, Inc
 * Copyright 2020-2021 Equinix, Inc
 * Copyright 2014-2021 The Billing Project, LLC
 *
 * The Billing Project licenses this file to you under the Apache License, version 2.0
 * (the "License"); you may not use this file except in compliance with the
 * License.  You may obtain a copy of the License at:
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the
 * License for the specific language governing permissions and limitations
 * under the License.
 */


package org.killbill.billing.client.model.gen;

import java.util.Objects;
import java.util.Arrays;
import java.math.BigDecimal;

/**
 *           DO NOT EDIT !!!
 *
 * This code has been generated by the Kill Bill swagger generator.
 *  @See https://github.com/killbill/killbill-swagger-coden
 */
import org.killbill.billing.client.model.KillBillObject;

public class BlockPrice {

    private String unitName = null;

    private BigDecimal size = null;

    private BigDecimal price = null;

    private BigDecimal max = null;


    public BlockPrice() {
    }

    public BlockPrice(final String unitName,
                     final BigDecimal size,
                     final BigDecimal price,
                     final BigDecimal max) {
        this.unitName = unitName;
        this.size = size;
        this.price = price;
        this.max = max;

    }


    public BlockPrice setUnitName(final String unitName) {
        this.unitName = unitName;
        return this;
    }

    public String getUnitName() {
        return unitName;
    }

    public BlockPrice setSize(final BigDecimal size) {
        this.size = size;
        return this;
    }

    public BigDecimal getSize() {
        return size;
    }

    public BlockPrice setPrice(final BigDecimal price) {
        this.price = price;
        return this;
    }

    public BigDecimal getPrice() {
        return price;
    }

    public BlockPrice setMax(final BigDecimal max) {
        this.max = max;
        return this;
    }

    public BigDecimal getMax() {
        return max;
    }

    @Override
    public boolean equals(java.lang.Object o) {
        if (this == o) {
            return true;
        }
        if (o == null || getClass() != o.getClass()) {
            return false;
        }
        BlockPrice blockPrice = (BlockPrice) o;
        return Objects.equals(this.unitName, blockPrice.unitName) &&
            Objects.equals(this.size, blockPrice.size) &&
            Objects.equals(this.price, blockPrice.price) &&
            Objects.equals(this.max, blockPrice.max);
    }

    @Override
    public int hashCode() {
        return Objects.hash(unitName,
            size,
            price,
            max);
    }

    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();
        sb.append("class BlockPrice {\n");
        
        sb.append("    unitName: ").append(toIndentedString(unitName)).append("\n");
        sb.append("    size: ").append(toIndentedString(size)).append("\n");
        sb.append("    price: ").append(toIndentedString(price)).append("\n");
        sb.append("    max: ").append(toIndentedString(max)).append("\n");
        sb.append("}");
        return sb.toString();
    }

    /**
     * Convert the given object to string with each line indented by 4 spaces
     * (except the first line).
     */
    private String toIndentedString(java.lang.Object o) {
        if (o == null) {
            return "null";
        }
        return o.toString().replace("\n", "\n    ");
    }
}

